import argparse
import torch


def args_parser():
    parser = argparse.ArgumentParser()

    parser.add_argument('--epoch', type=int, default=1, help='number of rounds of training')
    parser.add_argument('--round', type=int, default=40, help='number of communication rounds')
    parser.add_argument('--clients', type=int, default=6, help='number of total clients')
    parser.add_argument('--input_dim', type=int, default=28, help='input dimension')
    parser.add_argument('--lr', type=float, default=0.001, help='learning rate')
    parser.add_argument('--sampling', type=float, default=1, help='sampling rate')
    parser.add_argument('--batch', type=int, default=256, help='local batch size')
    parser.add_argument('--mu', type=float, default=0.01, help='proximal term constant')
    parser.add_argument('--optimizer', type=str, default='adam', help='type of optimizer')
    parser.add_argument('--device', default=torch.device("cuda" if torch.cuda.is_available() else "cpu"))
    parser.add_argument('--decay', type=float, default=1e-4, help='weight decay')
    parser.add_argument('--step_size', type=int, default=100, help='step size')
    parser.add_argument('--gamma', type=float, default=0.1, help='learning rate decay per global round')
    clients = [str(i) for i in range(0, 6)]
    parser.add_argument('--clients', default=clients)

    args = parser.parse_args()

    return args

