
import sys

import numpy as np
import pandas as pd
import torch
from args import args_parser
from pytorch_datasets_s1 import Ben19Dataset
from pytorch_datasets_s2 import Ben19Dataset1
sys.path.append('../')
from torch.utils.data import Dataset, DataLoader

args = args_parser()
device = torch.device("cuda" if torch.cuda.is_available() else "cpu")


class MyDataset(Dataset):
    def __init__(self, data):
        self.data = data

    def __getitem__(self, item):
        return self.data[item]

    def __len__(self):
        return len(self.data)


def nn_seq_wind(k):
    lmdb_path = '/faststorage/BigEarthNet_S1_S2/BEN_S1_S2.lmdb'
    batch_size=256
    num_workers=4
    
    
    
    if(k==0):
            csv_train_path='/data/switzerland_train.csv'
            training_set = Ben19Dataset1(lmdb_path=lmdb_path, csv_path=csv_train_path, img_transform='default')
            train_loader = DataLoader(training_set, batch_size=batch_size, num_workers=num_workers,shuffle=True, pin_memory=True)

    elif(k==1):
            csv_train_path='/dataaustria_train.csv'
            training_set = Ben19Dataset1(lmdb_path=lmdb_path, csv_path=csv_train_path, img_transform='default')
            train_loader = DataLoader(training_set, batch_size=batch_size, num_workers=num_workers,shuffle=True, pin_memory=True)
    elif(k==2):
            csv_train_path='/data/lithuania_train.csv'
            training_set = Ben19Dataset1(lmdb_path=lmdb_path, csv_path=csv_train_path, img_transform='default')
            train_loader = DataLoader(training_set, batch_size=batch_size, num_workers=num_workers,shuffle=True, pin_memory=True)

    elif(k==3):
            csv_train_path='/data/switzerland_train.csv'
            training_set = Ben19Dataset(lmdb_path=lmdb_path, csv_path=csv_train_path, img_transform='default')
            train_loader = DataLoader(training_set, batch_size=batch_size, num_workers=num_workers,shuffle=True, pin_memory=True)
    elif(k==4):
            csv_train_path='/data/austria_train.csv'
            training_set = Ben19Dataset(lmdb_path=lmdb_path, csv_path=csv_train_path, img_transform='default')
            train_loader = DataLoader(training_set, batch_size=batch_size, num_workers=num_workers,shuffle=True, pin_memory=True)

    elif(k==5):
            csv_train_path='/data/lithuania_train.csv'
            training_set = Ben19Dataset(lmdb_path=lmdb_path, csv_path=csv_train_path, img_transform='default')
            train_loader = DataLoader(training_set, batch_size=batch_size, num_workers=num_workers,shuffle=True, pin_memory=True)
    



    csv_val_path='/data/all_test.csv'
    val_set = Ben19Dataset(lmdb_path=lmdb_path, csv_path=csv_val_path, img_transform='default')
    val_loader = DataLoader(val_set, batch_size=batch_size, num_workers=num_workers,shuffle=True, pin_memory=True)


    return train_loader,val_loader 

def get_mape(x, y):
    """
    :param x:true
    :param y:pred
    :return:MAPE
    """
    return np.mean(np.abs((x - y) / x))
